//--------------------------------------------------------------------------
//	DIR̃Tv
//--------------------------------------------------------------------------
import std.file;
import std.stream;

version (Win32)
{
	import std.c.windows.windows;
}
version (linux)
{
	private import std.c.linux.linux;
}

//--------------------------------------------------------------------------
//p[^ɂ͕\Ώۂ̃fBNgw肷
//--------------------------------------------------------------------------
void main(char[][] arg)
{
	//Np[^`FbN
	if (arg.length <= 1) {
		stdout.writeLine("Usage: dir_sample.exe <path>");
		return;
	}
	char[] path = arg[1];

	//fBNg̑Ó`FbN
	if (!isdir(path)) {
		stdout.writeLine(path ~ "is not dir.");
		return;
	}
	chdir(path);

	try {
		//wfBNg̃t@Cꗗ\
		char[] fileattr;
		char[][] filelist = listdir(path);
		foreach (char[] filename; filelist) {
			//t@CTCY
			uint filesize = getSize(filename);

			//t@C
			char[] fileattr;
			uint attr = getAttributes(filename);
			version (Win32)
			{
				fileattr ~= (attr & FILE_ATTRIBUTE_ARCHIVE)		?	"A" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_COMPRESSED)	?	"C" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_DIRECTORY)	?	"D" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_HIDDEN)		?	"H" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_NORMAL)		?	"N" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_READONLY)	?	"R" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_SYSTEM)		?	"S" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_TEMPORARY)	?	"T" : "-";
				fileattr ~= (attr & FILE_ATTRIBUTE_OFFLINE)		?	"O" : "-";
			}
			version (linux)
			{
				fileattr = ".........";
				//
				//WindowsłƂƂŎȗ
				//
			}

			//\
			stdout.printf("%-20.*s : %10d bytes : %.*s", filename, filesize, fileattr);

			//s
			version (Win32)
			{
				stdout.printf("\r");
			}
			stdout.printf("\n");
		}
	} catch (Exception exception) {
		stdout.writeString("Exception: ");
		exception.print();
	}
}
